// CodeGear C++Builder
// Copyright (c) 1995, 2010 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'LogShell.pas' rev: 22.00

#ifndef LogshellHPP
#define LogshellHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <ActiveX.hpp>	// Pascal unit
#include <ComObj.hpp>	// Pascal unit
#include <ShlObj.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Logshell
{
//-- type declarations -------------------------------------------------------
struct NOTIFYREGISTER;
typedef NOTIFYREGISTER *PNOTIFYREGISTER;

struct DECLSPEC_DRECORD NOTIFYREGISTER
{
	
public:
	_ITEMIDLIST *pidlPath;
	bool bWatchSubtree;
};


#pragma option push -b-
enum TSMLNotificationEvent { lnAssociationChange, lnAttributesChange, lnFileChange, lnFileCreate, lnFileDelete, lnFileRename, lnDriveAdd, lnDriveRemove, lnShellDriveAdd, lnDriveSpaceChange, lnMediaInsert, lnMediaRemove, lnFolderCreate, lnFolderDelete, lnFolderRename, lnFolderUpdate, lnNetShare, lnNetUnShare, lnServerDisconnect, lnImageListChange, lnEndSessionQuery };
#pragma option pop

typedef System::Set<TSMLNotificationEvent, TSMLNotificationEvent::lnAssociationChange, TSMLNotificationEvent::lnEndSessionQuery>  TSMLNotificationEvents;

typedef void __fastcall (__closure *TSMLShellNotificationEvent1)(System::TObject* Sender, System::UnicodeString Value);

typedef void __fastcall (__closure *TSMLShellNotificationEvent2)(System::TObject* Sender, System::UnicodeString OldValue, System::UnicodeString NewValue);

class DELPHICLASS TSMShellLog;
class PASCALIMPLEMENTATION TSMShellLog : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	TSMLNotificationEvents FOptions;
	System::UnicodeString FPath;
	bool FActive;
	bool FWatchSubTree;
	System::UnicodeString prevPath1;
	System::UnicodeString prevPath2;
	int PrevEvent;
	HWND Handle;
	HWND NotifyHandle;
	Classes::TNotifyEvent FOnAssociationChange;
	TSMLShellNotificationEvent2 FOnAttribChange;
	TSMLShellNotificationEvent1 FOnCreate;
	TSMLShellNotificationEvent1 FOnDelete;
	TSMLShellNotificationEvent1 FOnDriveAdd;
	TSMLShellNotificationEvent1 FOnDriveAddGui;
	TSMLShellNotificationEvent1 FOnDriveRemove;
	TSMLShellNotificationEvent1 FOnMediaInsert;
	TSMLShellNotificationEvent1 FOnMediaRemove;
	TSMLShellNotificationEvent1 FOnFolderCreate;
	TSMLShellNotificationEvent1 FOnNetShare;
	TSMLShellNotificationEvent1 FOnNetUnShare;
	TSMLShellNotificationEvent2 FOnRenameFolder;
	TSMLShellNotificationEvent2 FOnFileRename;
	TSMLShellNotificationEvent1 FOnFolderRemove;
	TSMLShellNotificationEvent1 FOnServerDisconnect;
	TSMLShellNotificationEvent1 FOnFolderUpdate;
	Classes::TNotifyEvent FOnEndSessionQuery;
	System::UnicodeString __fastcall PathFromPIDL(Shlobj::PItemIDList PIDL);
	void __fastcall SetOptions(const TSMLNotificationEvents Value);
	bool __fastcall GetActive(void);
	void __fastcall SetActive(const bool Value);
	void __fastcall SetPath(const System::UnicodeString Value);
	void __fastcall SetWatchSubTree(const bool Value);
	
protected:
	void __fastcall ShellNotifyRegister(void);
	void __fastcall ShellNotifyUnregister(void);
	void __fastcall WndProc(Messages::TMessage &Message);
	DYNAMIC void __fastcall DoAssociationChange(void);
	DYNAMIC void __fastcall DoAttributesChange(System::UnicodeString Path1, System::UnicodeString Path2);
	DYNAMIC void __fastcall DoCreateFile(System::UnicodeString Path);
	DYNAMIC void __fastcall DoDeleteFile(System::UnicodeString Path);
	DYNAMIC void __fastcall DoDriveAdd(System::UnicodeString Path);
	DYNAMIC void __fastcall DoDriveAddGui(System::UnicodeString Path);
	DYNAMIC void __fastcall DoDriveRemove(System::UnicodeString Path);
	DYNAMIC void __fastcall DoMediaInsert(System::UnicodeString Path);
	DYNAMIC void __fastcall DoMediaRemove(System::UnicodeString Path);
	DYNAMIC void __fastcall DoDirCreate(System::UnicodeString Path);
	DYNAMIC void __fastcall DoNetShare(System::UnicodeString Path);
	DYNAMIC void __fastcall DoNetUnShare(System::UnicodeString Path);
	DYNAMIC void __fastcall DoRenameFolder(System::UnicodeString Path1, System::UnicodeString Path2);
	DYNAMIC void __fastcall DoRenameItem(System::UnicodeString Path1, System::UnicodeString Path2);
	DYNAMIC void __fastcall DoFolderRemove(System::UnicodeString Path);
	DYNAMIC void __fastcall DoServerDisconnect(System::UnicodeString Path);
	DYNAMIC void __fastcall DoDirUpdate(System::UnicodeString Path);
	
public:
	__fastcall virtual TSMShellLog(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMShellLog(void);
	
__published:
	__property System::UnicodeString Path = {read=FPath, write=SetPath};
	__property bool Active = {read=GetActive, write=SetActive, nodefault};
	__property bool WatchSubTree = {read=FWatchSubTree, write=SetWatchSubTree, nodefault};
	__property TSMLNotificationEvents Options = {read=FOptions, write=SetOptions, nodefault};
	__property Classes::TNotifyEvent OnAssociationChange = {read=FOnAssociationChange, write=FOnAssociationChange};
	__property TSMLShellNotificationEvent2 OnAttributesChange = {read=FOnAttribChange, write=FOnAttribChange};
	__property TSMLShellNotificationEvent1 OnFileCreate = {read=FOnCreate, write=FOnCreate};
	__property TSMLShellNotificationEvent2 OnFolderRename = {read=FOnRenameFolder, write=FOnRenameFolder};
	__property TSMLShellNotificationEvent1 OnFolderUpdate = {read=FOnFolderUpdate, write=FOnFolderUpdate};
	__property TSMLShellNotificationEvent1 OnFileDelete = {read=FOnDelete, write=FOnDelete};
	__property TSMLShellNotificationEvent1 OnDriveAdd = {read=FOnDriveAdd, write=FOnDriveAdd};
	__property TSMLShellNotificationEvent1 OnFolderRemove = {read=FOnFolderRemove, write=FOnFolderRemove};
	__property TSMLShellNotificationEvent2 OnFileRename = {read=FOnFileRename, write=FOnFileRename};
	__property TSMLShellNotificationEvent1 OnDriveAddGui = {read=FOnDriveAddGui, write=FOnDriveAddGui};
	__property TSMLShellNotificationEvent1 OnDriveRemove = {read=FOnDriveRemove, write=FOnDriveRemove};
	__property TSMLShellNotificationEvent1 OnMediaInserted = {read=FOnMediaInsert, write=FOnMediaInsert};
	__property TSMLShellNotificationEvent1 OnMediaRemove = {read=FOnMediaRemove, write=FOnMediaRemove};
	__property TSMLShellNotificationEvent1 OnFolderCreate = {read=FOnFolderCreate, write=FOnFolderCreate};
	__property TSMLShellNotificationEvent1 OnNetShare = {read=FOnNetShare, write=FOnNetShare};
	__property TSMLShellNotificationEvent1 OnNetUnShare = {read=FOnNetUnShare, write=FOnNetUnShare};
	__property TSMLShellNotificationEvent1 OnServerDisconnect = {read=FOnServerDisconnect, write=FOnServerDisconnect};
	__property Classes::TNotifyEvent OnEndSessionQuery = {read=FOnEndSessionQuery, write=FOnEndSessionQuery};
};


//-- var, const, procedure ---------------------------------------------------
static const System::Word SNM_SHELLNOTIFICATION = 0x401;
static const System::ShortInt SHCNF_ACCEPT_INTERRUPTS = 0x1;
static const System::ShortInt SHCNF_ACCEPT_NON_INTERRUPTS = 0x2;
static const System::Word SHCNF_NO_PROXY = 0x8000;
extern PACKAGE HWND __stdcall SHChangeNotifyRegister(HWND hWnd, int dwFlags, unsigned wEventMask, unsigned uMsg, int cItems, PNOTIFYREGISTER lpItems);
extern PACKAGE bool __stdcall SHChangeNotifyDeregister(HWND hWnd);
extern PACKAGE HRESULT __stdcall SHILCreateFromPath(void * Path, Shlobj::PItemIDList PIDL, unsigned &Attributes);

}	/* namespace Logshell */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE)
using namespace Logshell;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// LogshellHPP
